"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _prismReactRenderer = require("prism-react-renderer");

var _prismReactRenderer2 = _interopRequireDefault(_prismReactRenderer);

var _duotoneDark = require("prism-react-renderer/themes/duotoneDark");

var _duotoneDark2 = _interopRequireDefault(_duotoneDark);

var _duotoneLight = require("prism-react-renderer/themes/duotoneLight");

var _duotoneLight2 = _interopRequireDefault(_duotoneLight);

var _scroller = require("./scroller");

var Scroller = _interopRequireWildcard(_scroller);

var _glamor = require("glamor");

var _stepParser = require("./step-parser");

var _stepParser2 = _interopRequireDefault(_stepParser);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var selectedRules = (0, _glamor.css)({
  opacity: 1,
  transition: "opacity 300ms"
});
var unselectedRules = (0, _glamor.css)({
  opacity: 0.3,
  transition: "opacity 300ms"
});

var CodeSurfer = function CodeSurfer(_ref) {
  var code = _ref.code,
      step = _ref.step,
      lang = _ref.lang,
      showNumbers = _ref.showNumbers,
      dark = _ref.dark,
      theme = _ref.theme;

  var tokensPerLine = (0, _stepParser2.default)(step);
  var isSelected = function isSelected(lineIndex, tokenIndex) {
    return tokensPerLine[lineIndex + 1] !== undefined && (tokensPerLine[lineIndex + 1] === null || tokensPerLine[lineIndex + 1].includes(tokenIndex));
  };
  return _react2.default.createElement(
    _prismReactRenderer2.default,
    _extends({}, _prismReactRenderer.defaultProps, {
      code: code,
      language: lang || "jsx",
      theme: theme !== undefined ? theme : dark ? _duotoneDark2.default : _duotoneLight2.default
    }),
    function (_ref2) {
      var className = _ref2.className,
          style = _ref2.style,
          tokens = _ref2.tokens,
          getLineProps = _ref2.getLineProps,
          getTokenProps = _ref2.getTokenProps;
      return _react2.default.createElement(
        Scroller.Container,
        {
          type: "pre",
          className: className,
          style: Object.assign({}, style, { background: null })
        },
        _react2.default.createElement(
          Scroller.Content,
          { type: "code" },
          tokens.map(function (line, i) {
            return _react2.default.createElement(
              "div",
              getLineProps({ line: line, key: i }),
              showNumbers && _react2.default.createElement(
                "span",
                {
                  className: "token comment " + (tokensPerLine[i + 1] !== undefined ? selectedRules : unselectedRules),
                  style: { userSelect: "none" }
                },
                (i + 1 + ".").padStart(3),
                " "
              ),
              line.map(function (token, key) {
                return _react2.default.createElement(Scroller.Element, _extends({
                  type: "span"
                }, getTokenProps({
                  token: token,
                  key: key,
                  selected: isSelected(i, key),
                  className: isSelected(i, key) ? selectedRules : unselectedRules
                })));
              })
            );
          })
        )
      );
    }
  );
};

exports.default = CodeSurfer;